Summary:	Set irq and rps affinity for Multi-queue netcards
Name:		opencloudos-irqaffinity	
Version:	1.0
Release:	2%{?dist}
License:	GPLv2

BuildArch: 	noarch
URL:		http://www.opencloudos.org/	
Source0:	%{name}-%{version}.tar.gz
Requires:		systemd python3 bash
BuildRequires:		systemd-devel
Requires(post):		systemd-units
Requires(preun):	systemd-units
Requires(postun):	systemd-units

%description
setting up irq affinity according to /proc/irq/*/eth*
intel, broadcom, mellanox and chelsio netcards are supported.
setting up megasas affinity according to /proc/interrupts.
setting up mpt3sas affinity according to /proc/interrupts.
setting up mpt2sas affinity according to /proc/interrupts.
setting up nvme affinity according to /proc/interrupts.
setting up vmd affinity according to /proc/interrupts.
setting up irq affinity for network card using amd cpu.

%prep
%setup -q

%build

%install
rm -rf $RPM_BUILD_ROOT
install -d -m755 $RPM_BUILD_ROOT/%{_unitdir}
install -m644 opencloudos-irqaffinity.service $RPM_BUILD_ROOT/%{_unitdir}/opencloudos-irqaffinity.service
mkdir -p $RPM_BUILD_ROOT/usr/sbin
install -m 755 opencloudos_irqaffinity $RPM_BUILD_ROOT/usr/sbin/
install -m 755 opencloudos_set_irq_affinity.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 opencloudos_set_rps_cpus.py $RPM_BUILD_ROOT/usr/sbin/
install -m 755 opencloudos_set_irq_nvme.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 opencloudos_set_irq_vmd_corebalance.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 opencloudos_set_irq_megasas.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 opencloudos_set_irq_mpt3sas.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 opencloudos_set_irq_mpt2sas.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 opencloudos_set_irq_affinity_amd.sh $RPM_BUILD_ROOT/usr/sbin
install -m 755 opencloudos_set_rps_cpus_amd.py $RPM_BUILD_ROOT/usr/sbin/
install -m 755 opencloudos_set_irq_affinity_mlnx.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 mlnx_set_irq_affinity.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 mlnx_set_irq_affinity_bynode.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 mlnx_common_irq_affinity.sh $RPM_BUILD_ROOT/usr/sbin/

%post
%systemd_post opencloudos-irqaffinity.service

%preun
%systemd_preun opencloudos-irqaffinity.service

%postun
%systemd_postun_with_restart opencloudos-irqaffinity.service

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%attr(0644,root,root) %{_unitdir}/opencloudos-irqaffinity.service
%config %attr(0755,root,root) /usr/sbin/opencloudos_irqaffinity 
%config %attr(0755,root,root) /usr/sbin/opencloudos_set_irq_affinity.sh
%config %attr(0755,root,root) /usr/sbin/opencloudos_set_rps_cpus.py
%config %attr(0755,root,root) /usr/sbin/opencloudos_set_irq_nvme.sh
%config %attr(0755,root,root) /usr/sbin/opencloudos_set_irq_vmd_corebalance.sh
%config %attr(0755,root,root) /usr/sbin/opencloudos_set_irq_megasas.sh
%config %attr(0755,root,root) /usr/sbin/opencloudos_set_irq_mpt3sas.sh
%config %attr(0755,root,root) /usr/sbin/opencloudos_set_irq_mpt2sas.sh
%config %attr(0755,root,root) /usr/sbin/opencloudos_set_irq_affinity_amd.sh
%config %attr(0755,root,root) /usr/sbin/opencloudos_set_rps_cpus_amd.py
%config %attr(0755,root,root) /usr/sbin/opencloudos_set_irq_affinity_mlnx.sh
%config %attr(0755,root,root) /usr/sbin/mlnx_set_irq_affinity_bynode.sh
%config %attr(0755,root,root) /usr/sbin/mlnx_set_irq_affinity.sh
%config %attr(0755,root,root) /usr/sbin/mlnx_common_irq_affinity.sh

%changelog
* Thu Sep 15 2022 Xun Zhong <invain@opencloudos.tech> - 1.0-2
- fix service syntax, remove set_irq_nvme

* Thu May 19 2022 Songqiao Tao <joeytao@tencent.com> - 1.0-1
- Initial for OpenCloudOS
